<script setup lang="ts">
import { computed, onMounted, reactive, ref } from "vue";
import type { NewsIn, NewsOut } from "@/client/types.gen.ts";
import NewsRenderer from "@/components/news/NewsRenderer.vue";
import dayjs from "dayjs";
import { useNewsStore, useUserStore } from "@/stores";
import NewsCard from "@/components/news/NewsCard.vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { Toast, Tooltip } from "bootstrap";
import BootstrapToast from "@/components/BootstrapToast.vue";

const userRepository = useUserStore();
const newsRepository = useNewsStore();

const formState = reactive<{
  sending: boolean;
  newsEvent: NewsIn;
}>({
  sending: false,
  newsEvent: {
    category: "system",
    content: "",
    title: "",
    important_till: undefined,
  },
});

const newsOut = computed<NewsOut>(() => {
  return {
    ...formState.newsEvent,
    category: formState.newsEvent.category!,
    created_at: dayjs().unix(),
    creator_id: userRepository.currentUID,
    news_id: "",
  };
});

const notificationCreateForm = ref<HTMLFormElement | undefined>(undefined);
let successToast: Toast;

function saveNewsEvent() {
  if (notificationCreateForm.value?.checkValidity()) {
    formState.sending = true;
    newsRepository
      .createNewsEvent(formState.newsEvent)
      .then(() => {
        successToast.show();
        resetForm();
      })
      .finally(() => {
        formState.sending = false;
      });
  }
}

function importantTillTimestampChanged(target?: HTMLInputElement | null) {
  formState.newsEvent.important_till = target?.value
    ? dayjs(target?.value).unix()
    : undefined;
}

function resetForm() {
  formState.newsEvent = {
    category: "system",
    content: "",
    title: "",
    important_till: undefined,
  };
}

onMounted(() => {
  Tooltip.getOrCreateInstance("#create-news-event-timestamp-tooltip");
  successToast = Toast.getOrCreateInstance("#create-news-event-success-toast");
});
</script>

<template>
  <bootstrap-toast toast-id="create-news-event-success-toast">
    Successfully created news event
  </bootstrap-toast>
  <div class="row border-bottom mb-4">
    <h2 class="mb-2">Send a new notification</h2>
  </div>
  <form ref="notificationCreateForm" class="mb-5">
    <div class="mb-3">
      <label for="create-news-event-title-input" class="form-label"
        >Title</label
      >
      <input
        id="create-news-event-title-input"
        v-model="formState.newsEvent.title"
        type="text"
        required
        minlength="3"
        maxlength="256"
        class="form-control"
        :disabled="formState.sending"
      />
    </div>
    <div class="mb-3">
      <label for="create-news-event-content-input" class="form-label"
        >Content</label
      >
      <textarea
        id="create-news-event-content-input"
        v-model="formState.newsEvent.content"
        minlength="16"
        required
        maxlength="65536"
        class="form-control"
        rows="7"
        :disabled="formState.sending"
        aria-describedby="create-news-event-content-help"
      />
      <div id="create-news-event-content-help" class="form-text">
        The
        <a
          href="https://markdownguide.offshoot.io/basic-syntax/"
          target="_blank"
        >
          <font-awesome-icon icon="fa-brands fa-markdown" />
          Markdown syntax</a
        >
        is supported
      </div>
    </div>
    <div class="mb-3 row">
      <div class="col">
        <label for="create-news-event-category-select" class="form-label"
          >Notification category</label
        >
        <select
          id="create-news-event-category-select"
          v-model="formState.newsEvent.category"
          class="form-select"
          :disabled="formState.sending"
          required
        >
          <option value="system">System notification</option>
          <option value="resource">Resource notification</option>
          <option value="workflow">Workflow notification</option>
        </select>
      </div>
      <div class="col">
        <label for="create-news-event-timestamp-input" class="form-label"
          >Important till</label
        >
        <div class="input-group">
          <input
            id="create-news-event-timestamp-input"
            type="date"
            class="form-control"
            :disabled="formState.sending"
            :min="dayjs().add(1, 'day').format('YYYY-MM-DD')"
            :value="
              formState.newsEvent.important_till
                ? dayjs
                    .unix(formState.newsEvent.important_till)
                    .format('YYYY-MM-DD')
                : undefined
            "
            @input="
              (event) =>
                importantTillTimestampChanged(event.target as HTMLInputElement)
            "
          />
          <div
            id="create-news-event-timestamp-tooltip"
            class="input-group-text hover-info"
            data-bs-toggle="tooltip"
            data-bs-title="You can define how long this news event should be listed as latest news. The current default is two weeks."
          >
            <font-awesome-icon icon="fa-solid fa-circle-question" />
          </div>
        </div>
      </div>
    </div>
    <button
      type="submit"
      class="btn btn-primary"
      :disabled="formState.sending"
      @click="saveNewsEvent()"
    >
      Save
    </button>
  </form>
  <h3 class="mt-5">Preview</h3>
  <div class="row">
    <div class="col-8">
      <h4>News Event page</h4>
      <div class="border rounded py-2 px-1">
        <news-renderer :news-event="newsOut" />
      </div>
    </div>
    <div class="col-4">
      <h4>News Card</h4>
      <news-card :event="newsOut" />
    </div>
  </div>
</template>

<style scoped></style>
